<template>
    <div class="edit-popup">
        <popup
            ref="popupRef"
            :title="popupTitle"
            :async="true"
            width="70%"
            @confirm="handleSubmit"
            @close="handleClose"
        >
            <el-form ref="formRef" :model="formData" label-width="90px" :rules="formRules">
                <el-form-item label="手册栏目" prop="group_uid">
                    <el-select
                        v-model="formData.group_uid"
                        placeholder="请选择手册栏目"
                        clearable
                        style="width: 100%;"
                        fit-input-width="true"
                    >
                        <el-option
                            v-for="item in optionsData.group_cate"
                            :key="item.uid"
                            :label="item.title"
                            :value="item.uid"
                        />
                    </el-select>
                </el-form-item>
                <el-form-item label="手册标题" prop="title">
                    <el-input v-model="formData.title" clearable placeholder="请输入手册标题" />
                </el-form-item>
                <el-form-item label="显示状态" prop="is_show">
                    <el-radio-group v-model="formData.is_show" placeholder="请选择显示状态">
                        <el-radio
                            v-for="(item, index) in dictData.show_status"
                            :key="index"
                            :label="parseInt(item.value)"
                        >
                            {{ item.name }}
                        </el-radio>
                    </el-radio-group>
                </el-form-item>
                <el-form-item label="显示权重" prop="sort">
                    <div>
                        <el-input-number v-model="formData.sort" :min="0" />
                        <div class="form-tips">默认为0， 数值越大越排前</div>
                    </div>
                </el-form-item>
                <el-form-item label="手册内容" prop="content">
                    <editor class="flex-1" v-model="formData.content" :height="auto" />
                </el-form-item>
            </el-form>
        </popup>
    </div>
</template>

<script lang="ts" setup name="documentEdit">
import type { FormInstance } from 'element-plus'
import Popup from '@/components/popup/index.vue'
import { useDictOptions } from '@/hooks/useDictOptions'
import { apiDocumentAdd, apiDocumentEdit, apiDocumentDetail } from '@/api/document'
import { apiDocumentGroupAll } from "@/api/document_group"
import type { PropType } from 'vue'
defineProps({
    dictData: {
        type: Object as PropType<Record<string, any[]>>,
        default: () => ({})
    }
})
const emit = defineEmits(['success', 'close'])
const formRef = shallowRef<FormInstance>()
const popupRef = shallowRef<InstanceType<typeof Popup>>()
const mode = ref('add')

const { optionsData } = useDictOptions<{
    group_cate: any[]
}>({
    group_cate: {
        api: apiDocumentGroupAll
    }
})

// 弹窗标题
const popupTitle = computed(() => {
    return mode.value == 'edit' ? '编辑手册管理' : '新增手册管理'
})

// 表单数据
const formData = reactive({
    id: '',
    group_uid: '',
    title: '',
    content: '',
    is_show: 1,
    sort: 0,
})


// 表单验证
const formRules = reactive<any>({
    group_uid: [{
        required: true,
        message: '请选择手册栏目',
        trigger: ['blur']
    }],
    title: [{
        required: true,
        message: '请输入手册标题',
        trigger: ['blur']
    }],
    content: [{
        required: true,
        message: '请输入手册内容',
        trigger: ['blur']
    }],
    is_show: [{
        required: true,
        message: '请选择显示状态',
        trigger: ['blur']
    }],
    sort: [{
        required: true,
        message: '请输入显示权重',
        trigger: ['blur']
    }]
})


// 获取详情
const setFormData = async (data: Record<any, any>) => {
    for (const key in formData) {
        if (data[key] != null && data[key] != undefined) {
            //@ts-ignore
            formData[key] = data[key]
        }
    }
    
    
}

const getDetail = async (row: Record<string, any>) => {
    const data = await apiDocumentDetail({
        id: row.id
    })
    setFormData(data)
}


// 提交按钮
const handleSubmit = async () => {
    await formRef.value?.validate()
    const data = { ...formData,  }
    mode.value == 'edit' 
        ? await apiDocumentEdit(data) 
        : await apiDocumentAdd(data)
    popupRef.value?.close()
    emit('success')
}

//打开弹窗
const open = (type = 'add') => {
    mode.value = type
    popupRef.value?.open()
}

// 关闭回调
const handleClose = () => {
    emit('close')
}



defineExpose({
    open,
    setFormData,
    getDetail
})
</script>
